IdObject:
  type: object
  properties:
    id:
      type: integer
      description: id
      example: 1

IdsObject:
  type: object
  properties:
    ids:
      type: array
      items:
        type: integer
        description: id
        example: 1
  required:
    - ids

File:
  type: object
  properties:
    path:
      type: string
      description: Path to file relative to root of domain disk
      example: "attachments/48/2f/image.png"
    root_path:
      type: string
      description: Path to file relative to root of physical disk ensi
      example: "protected/domain/attachments/48/2f/image.png"
    url:
      type: string
      description: Link to download the file
      example: "https://es-public.project.ru/domain/attachments/48/2f/image.png"

FileOrNull:
  type: object
  nullable: true
  properties:
    path:
      type: string
      description: Path to file relative to root of domain disk
      example: "attachments/48/2f/image.png"
    root_path:
      type: string
      description: Path to file relative to root of physical disk ensi
      example: "protected/domain/attachments/48/2f/image.png"
    url:
      type: string
      description: Link to download the file
      example: "https://es-public.project.ru/domain/attachments/48/2f/image.png"

MultipartFileUploadRequest:
  type: object
  properties:
    file:
      type: string
      format: binary
      description: Downloadable file

PaginationTypeCursorEnum:
  type: string
  description: >
    * Pagination types:
    * `cursor` - Pagination using cursor
  enum:
    - cursor
  x-enum-varnames:
    - CURSOR

PaginationTypeOffsetEnum:
  type: string
  description: >
    * Pagination types:
    * `offset` - Pagination using offset
  enum:
    - offset
  x-enum-varnames:
    - OFFSET

PaginationTypeEnum:
  type: string
  description: |
    Pagination types:
    * `cursor` - Pagination using cursor
    * `offset` - Pagination using offset
  enum:
    - cursor
    - offset
  x-enum-varnames:
    - CURSOR
    - OFFSET

RequestBodySort:
  type: array
  example: []
  items:
    type: string

RequestBodyInclude:
  type: array
  example: []
  items:
    type: string


RequestBodyPagination:
  oneOf:
    - $ref: '#/RequestBodyCursorPagination'
    - $ref: '#/RequestBodyOffsetPagination'

RequestBodyCursorPagination:
  type: object
  properties:
    cursor:
      type: string
      example: null
      nullable: true
    limit:
      type: integer
      example: 20
    type:
      description: Pagination type
      allOf:
        - type: string
        - $ref: '#/PaginationTypeCursorEnum'

RequestBodyOffsetPagination:
  type: object
  properties:
    limit:
      type: integer
      example: 20
    offset:
      type: integer
      example: 0
    type:
      description: Pagination type
      allOf:
        - type: string
        - $ref: '#/PaginationTypeOffsetEnum'

ResponseBodyPagination:
  oneOf:
    - $ref: '#/ResponseBodyCursorPagination'
    - $ref: '#/ResponseBodyOffsetPagination'

ResponseBodyCursorPagination:
  type: object
  properties:
    cursor:
      type: string
      example: "eyJpZCI6MTAsIl9wb2ludHNUb05leHRJdGVtcyI6dHJ1ZX0"
      nullable: true
    limit:
      type: integer
      example: 20
    next_cursor:
      type: string
      example: "eyJpZCI6MTAsIl9wb2ludHNUb05leHRJdGVtcyI6dHJ1ZX0"
      nullable: true
    previous_cursor:
      type: string
      example: "eyJpZCI6MTAsIl9wb2ludHNUb05leHRJdGVtcyI6dHJ1ZX0"
      nullable: true
    type:
      description: Pagination type
      allOf:
        - type: string
        - $ref: '#/PaginationTypeCursorEnum'

ResponseBodyOffsetPagination:
  type: object
  properties:
    limit:
      type: integer
      example: 20
    offset:
      type: integer
      example: 0
    total:
      type: integer
      example: 253
    type:
      description: Pagination type
      allOf:
        - type: string
        - $ref: '#/PaginationTypeOffsetEnum'
